
#ifndef _pp_inline_h_
#define _pp_inline_h_

#include "tokenizer.h"

namespace ge
{



    /*
template <typename T>
void toSStreamSingle(Tokenizer & toks, stringstream & ss, T value)
{
    //ss << value ;

	while (toks.hasMoreToken())
	{
		string t = toks.nextToken();
		if (t != "$")
		{
			ss << t;
			break;
		}
	}



	ss << value ;

	//ss << value << " ";
}
*/


    // if expression starts with "$" we must consider this
    template<typename T>
    void toSStreamSingle(Tokenizer &toks, stringstream &ss, T value)
    {
        bool flagFistDollar = false;
        if (toks.remain() == toks.size() && toks.peekNextToken() == "$")
        {
            ss << value;
            flagFistDollar = true;
        }
        //ss << value ;

        while (toks.hasMoreToken())
        {
            string t = toks.nextToken();
            if (t != "$")
            {
                ss << t;
                break;
            }
        }


        if (!flagFistDollar)
            ss << value;

        //ss << value << " ";
    }


    // LAST
    template<typename T>
    void toSStream(Tokenizer &toks, stringstream &ss, const T &value)
    {
        toSStreamSingle(toks, ss, value);

        //if (toks.hasMoreToken())
        //ss << toks.nextToken();


        bool flagFirst = false;
        while (toks.hasMoreToken())
        {
            string t = toks.nextToken();
            if (!flagFirst)
            {
                flagFirst = true;
            } else
            {
                ss << t;
            }
        }



        //cout << "LAST" << endl;

    }


    template<typename First, typename ... Rest>
    void toSStream(Tokenizer &toks, stringstream &ss, const First &first, const Rest &... rest)
    {
        toSStreamSingle(toks, ss, first);
        toSStream(toks, ss, rest ...);
    }


    template<typename First, typename ... Rest>
    string _to_String(const char *pFormat, const First &first, const Rest &... rest)
    {
        if (!pFormat)
            return "";

        Tokenizer toks(pFormat, "$", true);

        stringstream ss;
        toSStream(toks, ss, first, rest ...);

        return ss.str();

    }

    template<typename First, typename ... Rest>
    void pp(const char *pFormat, const First &first, const Rest &... rest)
    {
        if (!pFormat)
            return;

        cout << _to_String(pFormat, first, rest ...) << endl;

    }

    template<typename First, typename ... Rest>
    void pp(unsigned int space, const char *pFormat, const First &first, const Rest &... rest)
    {
        if (!pFormat)
            return;

        for (unsigned i = 0; i < space; i++)
        {
            cout << " ";
        }

        cout << _to_String(pFormat, first, rest ...) << endl;

    }

    inline void pp()
    {
        cout << endl;
    }

    inline void pp(const string &s)
    {
        cout << s << endl;
    }

    inline void pp(std::nullptr_t)
    {
        cout << "nullptr" << endl;
    }

    inline void pp(const char *p)
    {
        if (p)
            pp((const string &) p);
        else
            pp(nullptr);
    }

    inline void pp(unsigned int space, const string &s)
    {
        for (unsigned i = 0; i < space; i++)
        {
            cout << " ";
        }

        cout << s << endl;

    }

}

#endif
