#ifndef _tokenizer_h_
#define _tokenizer_h_

namespace ge
{

    class Tokenizer
    {
    protected:
        mutable int index = 0;


        string delimiterAsString(char ch)
        {
            string s;
            s += ch;
            return s;
        }

    public:

        vector<std::string> v;

        Tokenizer()
        {

        }

        Tokenizer(const std::string &str, const std::string &delimiters = "/@", bool flagWithDelimiters = true)
        {
            scan(str, delimiters, flagWithDelimiters);
        }

        bool hasMoreToken() const
        {
            return index < (int) v.size();
        }

        string peekNextToken() const
        {
            return hasMoreToken() ? v[index] : "";

        }


        size_t remain() const
        {
            return v.size() - index;
        }

        size_t size() const
        {
            return v.size();

        }

        void reset()
        {
            v.clear();
        }

        string nextToken() const
        {
            return hasMoreToken() ? v[index++] : "";

        }

        void printSpace(unsigned space)
        {
            for (unsigned i = 0; i < space; i++)
            {
                cout << " ";
            }
        }

        void show(unsigned space = 0)
        {
            printSpace(space);
            cout << "Tokenizer:" << size() << " token" << endl;

            for (auto s : v)
            {
                printSpace(space + 4);
                cout << s << endl;
            }

        }

        void scan(const std::string &str, const std::string &delimiters = "/@", bool flagWithDelimiters = true)
        {
            reset();


            string::size_type delimPos = 0, tokenPos = 0, pos = 0;

            if (str.length() < 1)
                return;

            while (1)
            {
                delimPos = str.find_first_of(delimiters, pos);
                tokenPos = str.find_first_not_of(delimiters, pos);

                if (string::npos != delimPos)
                {
                    //cout << "DELIM " << str[delimPos] << "" << endl;
                    if (string::npos != tokenPos)
                    {
                        if (tokenPos < delimPos)
                        {
                            v.push_back(str.substr(pos, delimPos - pos));
                        } else
                        {
                            //tokens.push_back("");
                        }
                    } else
                    {
                        //tokens.push_back("");
                    }

                    if (flagWithDelimiters)
                        v.push_back(delimiterAsString(str[delimPos]));

                    pos = delimPos + 1;
                } else
                {
                    if (string::npos != tokenPos)
                    {
                        v.push_back(str.substr(pos));
                    } else
                    {
                        //tokens.push_back("");
                    }
                    break;
                }
            }

        }


    };

}
#endif
