#include "tools.h"
#include "CommandLine.h"
#include "toString.h"

namespace ge
{


    TestContextMap *TestContextAdder::tcm = nullptr;

    TestContextAdder::TestContextAdder(POINTER_TEST_COMMANDLINE pointerTest, const string &key, const string &description)
    {
        if (tcm == nullptr)
            tcm = new TestContextMap;

        tcm->addTestContext(key, TestContext(pointerTest));
    }

    TestContext &TestContextAdder::getTestContext(const string &key)
    {
        if (!tcm)
        {
            pp("TestContextAdder::getTestContext, tcm == nullptr");
            return TestContext::empty;
        }

        if (!tcm->hasTest(key))
        {
            pp("TestContextAdder::getTestContext, '$' not found", key);
            return TestContext::empty;
        }


        return tcm->mapTC[key];
    }
}