#include "testing.h"


#include <chrono>
#include <ctime>
#include <thread>
#include <string.h>




std::string time_point_to_string(std::chrono::system_clock::time_point &tp)
{
    using namespace std;
    using namespace std::chrono;

    auto ttime_t = system_clock::to_time_t(tp);
    auto tp_sec = system_clock::from_time_t(ttime_t);
    milliseconds ms = duration_cast<milliseconds>(tp - tp_sec);
    microseconds mcc = duration_cast<microseconds>(tp - tp_sec);

    std::tm * ttm = localtime(&ttime_t);

    char date_time_format[] = "%Y.%m.%d-%H.%M.%S";

    //char time_str[] = "yyyy.mm.dd.HH-MM.SS.fff";
    char time_str[] = "yyyy.mm.dd.HH-MM.SS.fff";

    strftime(time_str, strlen(time_str), date_time_format, ttm);

    string result(time_str);
    result.append(".");
    //result.append(to_string(ms.count()));
    result.append(to_string(mcc.count()));

    return result;
}


static int testTime2(CommandLine & cmd)
{

    pp("hello C++ 11 - time2");

    auto timeNow = chrono::system_clock::now();
    auto duration = timeNow.time_since_epoch();

    pp("nanos            :$", duration.count());

    double n = duration.count();
    uint64_t nt = duration.count();

    pp("nanos as double  :$", n);
    pp("nanos as uint64_t:$", nt);

    this_thread::sleep_for(chrono::milliseconds(1000));

    pp("wait...");


    timeNow = chrono::system_clock::now();
    duration = timeNow.time_since_epoch();
    double nn = duration.count() - n;

    uint64_t ntt = duration.count();

    pp("nanos            :$", duration.count());

    pp("diff(nanos)      :$", ntt-nt);
    pp("diff(double)     :$", nn/1000000000);
    pp("diff(double)     :$", toString(nn/1000000000));
    pp("diff(double)     :$", toString(nn/1000000000, 4));


    chrono::system_clock::time_point tp (duration);

    // display time_point:
    time_t tt = chrono::system_clock::to_time_t(tp);
    pp("time_point tp is : $", ctime(&tt));

    pp("time_point tp is : $", time_point_to_string(tp));





    return 0;
}

static TestContextAdder testi(testTime2, "time.nanos", "nanoseconds...");