#include <string.h>
#include "tools.h"
#include "CommandLine.h"
#include "toString.h"


namespace ge
{


    bool startsWith(const string &s, const string &t)
    {
        if (s.length() == 0 || t.length() == 0)
            return false;

        const char *pStr = s.c_str();
        const char *pPart = t.c_str();


        return pStr == strstr(pStr, pPart);
    }


    int toInt(const string &s)
    {
        return atoi(s.c_str());
    }

    int64_t toLONG(const string &s)
    {
        return atol(s.c_str());
    }

    uint64_t toULONG(const string &s)
    {
        return atol(s.c_str());
    }

    bool toBool(const string &s)
    {
        if (s.length() == 0)
            return false;

        if (s.length() == 1)
        {
            return s[0] == '1';
        }

        if (s == "true" || s == "TRUE" || s == "on" || s == "ON")
            return true;

        return false;
    }

    float toFloat(const string &s)
    {
        return atof(s.c_str());
    }

    double toDouble(const string &s)
    {
        return atof(s.c_str());

    }

}
