#include "tools.h"
#include "toString.h"
#include <stdarg.h>


namespace ge
{

    string gprintf(const char *pFormat, ...)
    {
        const int BUF_STRING_MAX = 1024 * 64;
        char buf [BUF_STRING_MAX + 1];

        va_list args;
        va_start(args, pFormat);
        vsnprintf(buf, BUF_STRING_MAX, pFormat, args);
        va_end(args);

        return buf;
    }

    string toString(char val)
    {
        stringstream ss;
        ss << val;
        return ss.str();
    }

    string toString(short val)
    {
        stringstream ss;
        ss << val;
        return ss.str();
    }

    string toString(int val)
    {
        stringstream ss;
        ss << val;
        return ss.str();
    }

    string toString(int64_t val)
    {
        stringstream ss;
        ss << val;
        return ss.str();
    }

    string toString(uint64_t val)
    {
        stringstream ss;
        ss << val;
        return ss.str();
    }

    string toString(float val)
    {
        stringstream ss;
        ss << val;
        return ss.str();
    }

    string toString(double val, uint8_t precise)
    {

        stringstream ss;
        //ss << std::setw( 11 ) <<  std::setfill( '0' ) << std::setprecision( 4) << val;
        ss << std::fixed << std::setprecision( precise)  << val;
        return ss.str();

        //return gprintf("%2.3f", val);
    }
}